#include <atl/object.hpp>
#include <atl/integer.h>
#include <atl/float.h>
#include <atl/double.h>
#include <atl/char.h>
#include <atl/long.h>
#include <atl/short.h>

using namespace cpptesk::atl;

template<>
const Type CppObject<bool>::type = CPPTESK_TYPE_CONSTANT_INIT(bool, "bool", &type_Char);

template<>
const Type CppObject<char>::type = CPPTESK_TYPE_CONSTANT_INIT(char, "char", &type_Char);

template<>
const Type CppObject<short>::type = CPPTESK_TYPE_CONSTANT_INIT(short, "short", &type_Short);

template<>
const Type CppObject<int>::type = CPPTESK_TYPE_CONSTANT_INIT(int, "int", &type_Integer);

template<>
const Type CppObject<long>::type = CPPTESK_TYPE_CONSTANT_INIT(long, "long", &type_Long);

template<>
const Type CppObject<long long>::type = CPPTESK_TYPE_CONSTANT_INIT(long long, "long long", &type_Long);

template<>
const Type CppObject<unsigned char>::type = CPPTESK_TYPE_CONSTANT_INIT(unsigned char, "uchar", &type_Char);

template<>
const Type CppObject<unsigned short>::type = CPPTESK_TYPE_CONSTANT_INIT(unsigned short, "ushort", &type_UShort);

template<>
const Type CppObject<unsigned int>::type = CPPTESK_TYPE_CONSTANT_INIT(unsigned int, "uint", &type_UInteger);

template<>
const Type CppObject<unsigned long>::type = CPPTESK_TYPE_CONSTANT_INIT(unsigned long, "ulong", &type_ULong);

template<>
const Type CppObject<unsigned long long>::type = CPPTESK_TYPE_CONSTANT_INIT(unsigned long long, "ulonglong", &type_ULong);

template<>
const Type CppObject<float>::type = CPPTESK_TYPE_CONSTANT_INIT(float, "float", &type_Float);

template<>
const Type CppObject<double>::type = CPPTESK_TYPE_CONSTANT_INIT(double, "double", &type_Double);

template<>
const Type CppObject<long double>::type = CPPTESK_TYPE_CONSTANT_INIT(long double, "longdouble", &type_Double);

template<>
const Type CppObject<char *>::type = CPPTESK_TYPE_CONSTANT_INIT(char*, "cstr", &type_String);

template<>
const Type CppObject<const char *>::type = CPPTESK_TYPE_CONSTANT_INIT(const char*, "const_cstr", &type_String);

template<>
const Type CppObject<std::string>::type = CPPTESK_TYPE_CONSTANT_INIT(std::string, "std::string", &type_Object);
