#pragma once
#include <ts/scenario/functors/scenario.hpp>
#include <ts/scenario/functors/methods.hpp>

namespace cpptesk
{
namespace ts
{

/** @typedef CppTestScenario
 * A test scenario description with C++ functors.
 */
struct CppTestScenario
{
    /// A test scenario name.
    const char*          name;
    /// A test scenario initialization function.
    scenario_init_base*  init;
    /// A test scenario function that calculates a generalized state.
    scenario_get_state_base* getState;
    /// A test scenario function that calculates a generalized state's identifier.
    scenario_get_state_id_base* getStateId;
    /// A test scenario function that saves the current state into an object.
    scenario_save_model_state_base*    saveModelState;
    /// A test scenario function that restores the current state.
    scenario_restore_model_state_base* restoreModelState;
    /// A test scenario function that checks whether the current state is stationary or not.
    scenario_is_stationary_state_base* isStationaryState;
    /// A test scenario function that observes the current state.
    scenario_observe_state_base*      observeState;
    /// A test scenario finalization function.
    scenario_finish_base*            finish;
    /// A list of scenario functions.
    scenario_method_base**  actions;
} ;

}
}
